diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.module b/drupal7/sites/all/modules/print/print_pdf/print_pdf.module
index 3ced06b4..de6500e2 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.module
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.module
@@ -170,6 +170,8 @@ function print_pdf_block_info() {
  * Implements hook_block_view().
  */
 function print_pdf_block_view($delta = 0) {
+  $block = array();
+
       switch ($delta) {
       case 'print_pdf-top':
         $block['subject'] = t('Most PDFd');
@@ -408,9 +410,15 @@ function print_pdf_node_insert($node) {
  */
 function print_pdf_node_update($node) {
   if (user_access('administer print') || user_access('node-specific print configuration')) {
-    if (!isset($node->print_pdf_display)) $node->print_pdf_display = variable_get('print_pdf_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
-    if (!isset($node->print_pdf_display_comment)) $node->print_pdf_display_comment = variable_get('print_pdf_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
-    if (!isset($node->print_pdf_display_urllist)) $node->print_pdf_display_urllist = variable_get('print_pdf_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    if (!isset($node->print_pdf_display) || $node->print_pdf_display === NULL) {
+      $node->print_pdf_display = variable_get('print_pdf_display_' . $node->type, PRINT_TYPE_SHOW_LINK_DEFAULT);
+    }
+    if (!isset($node->print_pdf_display_comment) || $node->print_pdf_display_comment === NULL) {
+      $node->print_pdf_display_comment = variable_get('print_pdf_display_comment_' . $node->type, PRINT_TYPE_COMMENT_LINK_DEFAULT);
+    }
+    if (!isset($node->print_pdf_display_urllist) || $node->print_pdf_display_urllist === NULL) {
+      $node->print_pdf_display_urllist = variable_get('print_pdf_display_urllist_' . $node->type, PRINT_TYPE_URLLIST_DEFAULT);
+    }
 
     _print_pdf_node_conf_modify($node->nid, $node->print_pdf_display, $node->print_pdf_display_comment, $node->print_pdf_display_urllist);
   }
@@ -675,19 +683,22 @@ function _print_pdf_tcpdf_version() {
   require_once(DRUPAL_ROOT . '/' . $print_pdf_pdf_tool);
 
   // Hide warnings, as some TCPDF constants may still be undefined
-  @$pdf = new TCPDF();
+  if (class_exists('TCPDF')) {
+    @$pdf = new TCPDF();
 
-  if (method_exists($pdf, 'getTCPDFVersion')) {
-    return $pdf->getTCPDFVersion();
-  }
-  elseif (defined('PDF_PRODUCER')) {
-    sscanf(PDF_PRODUCER, "TCPDF %s", $version);
+    if (class_exists('TCPDF_STATIC')) {
+      return TCPDF_STATIC::getTCPDFVersion();
+    }
+    elseif (method_exists($pdf, 'getTCPDFVersion')) {
+      return $pdf->getTCPDFVersion();
+    }
+    elseif (defined('PDF_PRODUCER')) {
+      sscanf(PDF_PRODUCER, "TCPDF %s", $version);
 
-    return $version;
-  }
-  else {
-    return 'unknown';
+      return $version;
+    }
   }
+  return 'unknown';
 }
 
 /**
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.pages.inc b/drupal7/sites/all/modules/print/print_pdf/print_pdf.pages.inc
index 50103ec7..e8e1a05a 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.pages.inc
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.pages.inc
@@ -44,12 +44,12 @@ function print_pdf_controller() {
 
     $pdf_filename = variable_get('print_pdf_filename', PRINT_PDF_FILENAME_DEFAULT);
     if (!empty($pdf_filename) && !empty($node)) {
-      $pdf_filename = token_replace($pdf_filename, array('node' => $node));
+      $pdf_filename = token_replace($pdf_filename, array('node' => $node), array('clear' => TRUE));
     }
     else {
-      $pdf_filename = token_replace($pdf_filename, array('site'));
-      if (empty($pdf_filename) || count(token_scan($pdf_filename))) {
-        // If there are still tokens, use a fallback solution
+      $pdf_filename = token_replace($pdf_filename, array('site'), array('clear' => TRUE));
+      if (empty($pdf_filename)) {
+        // If empty, use a fallback solution
         $pdf_filename = str_replace('/', '_', $path);
       }
     }
@@ -179,11 +179,11 @@ function _print_pdf_dompdf($print, $html, $filename = NULL) {
   $print_pdf_content_disposition = variable_get('print_pdf_content_disposition', PRINT_PDF_CONTENT_DISPOSITION_DEFAULT);
 
   if (variable_get('print_pdf_autoconfig', PRINT_PDF_AUTOCONFIG_DEFAULT)) {
-    define("DOMPDF_ENABLE_PHP", FALSE);
-    define("DOMPDF_ENABLE_REMOTE", TRUE);
-    define("DOMPDF_TEMP_DIR", file_directory_temp());
-    define("DOMPDF_UNICODE_ENABLED", variable_get('print_pdf_dompdf_unicode', PRINT_PDF_DOMPDF_UNICODE_DEFAULT));
-    define("DOMPDF_FONT_CACHE", drupal_realpath('public://' . PRINT_PDF_DOMPDF_CACHE_DIR_DEFAULT . '/fonts/'));
+    if (!defined('DOMPDF_ENABLE_PHP')) define("DOMPDF_ENABLE_PHP", FALSE);
+    if (!defined('DOMPDF_ENABLE_REMOTE')) define("DOMPDF_ENABLE_REMOTE", TRUE);
+    if (!defined('DOMPDF_TEMP_DIR')) define("DOMPDF_TEMP_DIR", file_directory_temp());
+    if (!defined('DOMPDF_UNICODE_ENABLED')) define("DOMPDF_UNICODE_ENABLED", variable_get('print_pdf_dompdf_unicode', PRINT_PDF_DOMPDF_UNICODE_DEFAULT));
+    if (!defined('DOMPDF_FONT_CACHE')) define("DOMPDF_FONT_CACHE", drupal_realpath('public://' . PRINT_PDF_DOMPDF_CACHE_DIR_DEFAULT . '/fonts/'));
   }
 
   require_once(DRUPAL_ROOT . '/' . $print_pdf_pdf_tool);
@@ -235,6 +235,10 @@ function _print_pdf_dompdf($print, $html, $filename = NULL) {
   }
   $html = htmlspecialchars_decode(htmlentities($html, ENT_NOQUOTES, 'ISO-8859-1'), ENT_NOQUOTES);
   }
+  else {
+    // Otherwise, ensure the content is properly formatted Unicode.
+    $html = mb_convert_encoding($html, 'HTML-ENTITIES', 'UTF-8');
+  }
 
   // Must get rid of tbody (dompdf goes into recursion)
   $html = preg_replace('!<tbody[^>]*?>|</tbody>!i', '', $html);
@@ -273,15 +277,15 @@ function _print_pdf_tcpdf($print, $html, $filename = NULL) {
   $pdf_tool_path = realpath(dirname($print_pdf_pdf_tool));
 
   if (variable_get('print_pdf_autoconfig', PRINT_PDF_AUTOCONFIG_DEFAULT)) {
-    define('K_TCPDF_EXTERNAL_CONFIG', TRUE);
-    define('K_PATH_MAIN', dirname($_SERVER['SCRIPT_FILENAME']));
-    define('K_PATH_URL', $base_url);
-    define('K_PATH_FONTS', $pdf_tool_path . '/fonts/');
-    define('K_PATH_CACHE', drupal_realpath('public://' . PRINT_PDF_TCPDF_CACHE_DIR_DEFAULT . '/cache/'));
-    define('K_PATH_IMAGES', '');
-    define('K_BLANK_IMAGE', $pdf_tool_path . '/images/_blank.png');
-    define('K_CELL_HEIGHT_RATIO', 1.25);
-    define('K_SMALL_RATIO', 2/3);
+    if (!defined('K_TCPDF_EXTERNAL_CONFIG')) define('K_TCPDF_EXTERNAL_CONFIG', TRUE);
+    if (!defined('K_PATH_MAIN')) define('K_PATH_MAIN', dirname($_SERVER['SCRIPT_FILENAME']));
+    if (!defined('K_PATH_URL')) define('K_PATH_URL', $base_url);
+    if (!defined('K_PATH_FONTS')) define('K_PATH_FONTS', $pdf_tool_path . '/fonts/');
+    if (!defined('K_PATH_CACHE')) define('K_PATH_CACHE', drupal_realpath('public://' . PRINT_PDF_TCPDF_CACHE_DIR_DEFAULT . '/cache') . '/');
+    if (!defined('K_PATH_IMAGES')) define('K_PATH_IMAGES', '');
+    if (!defined('K_BLANK_IMAGE')) define('K_BLANK_IMAGE', $pdf_tool_path . '/images/_blank.png');
+    if (!defined('K_CELL_HEIGHT_RATIO')) define('K_CELL_HEIGHT_RATIO', 1.25);
+    if (!defined('K_SMALL_RATIO')) define('K_SMALL_RATIO', 2/3);
   }
 
   // Try to use local file access for image files
@@ -291,7 +295,7 @@ function _print_pdf_tcpdf($print, $html, $filename = NULL) {
   $pattern = "!<img\s[^>]*?src\s*?=\s*?['\"]?{$base_url}[^>]*?>!is";
   $html = preg_replace_callback($pattern, create_function('$matches', 'return html_entity_decode($matches[0], ENT_QUOTES);'), $html);
   // Remove queries from the image URL
-  $pattern = "!(<img\s[^>]*?src\s*?=\s*?['\"]?{$base_url}[^>]*?)(?:%3F|\?)[\w=&]+([^>]*?>)!is";
+  $pattern = "!(<img\s[^>]*?src\s*?=\s*?['\"]?{$base_url}[^>]*?)(?:%3F|\?)[^\s'\"]+([^>]*?>)!is";
   $html = preg_replace($pattern, '$1$2', $html);
 
   require_once(DRUPAL_ROOT . '/' . $print_pdf_pdf_tool);
@@ -315,6 +319,7 @@ function _print_pdf_tcpdf($print, $html, $filename = NULL) {
   $pdf->SetTitle(html_entity_decode($print['title'], ENT_QUOTES, 'UTF-8'));
   $pdf->setPDFVersion('1.6');
   $pdf->setFontSubsetting(variable_get('print_pdf_font_subsetting', PRINT_PDF_FONT_SUBSETTING_DEFAULT));
+  $pdf->setTcpdfLink(false);
 
   if ($language->direction == LANGUAGE_RTL) {
     $pdf->setRTL(TRUE);
@@ -367,7 +372,7 @@ function _print_pdf_wkhtmltopdf($print, $html, $filename = NULL) {
   $dpi = 96;
 
   if (!empty($print_pdf_wkhtmltopdf_options)) {
-    $print_pdf_wkhtmltopdf_options = token_replace($print_pdf_wkhtmltopdf_options, array('node' => $print['node']));
+    $print_pdf_wkhtmltopdf_options = token_replace($print_pdf_wkhtmltopdf_options, array('node' => $print['node']), array('clear' => TRUE));
   }
 
   $version = _print_pdf_wkhtmltopdf_version();
@@ -405,7 +410,7 @@ function _print_pdf_wkhtmltopdf($print, $html, $filename = NULL) {
       if (empty($error)) {
         $error = 'No stderr output available.';
       }
-      watchdog('print_pdf', "wkhtmltopdf (returned $retval): $error");
+      watchdog('print_pdf', 'wkhtmltopdf [%cmd] (returned %ret): %error', array('%cmd' => $cmd, '%ret' => $retval, '%error' => $error));
     }
   }
 
@@ -431,7 +436,7 @@ function _print_pdf_wkhtmltopdf($print, $html, $filename = NULL) {
   }
   else {
     drupal_set_message(t('Unable to generate PDF file.'), 'error');
-    drupal_goto($meta['url']);
+    drupal_goto($print['url']);
     return NULL;
   }
 }
@@ -445,38 +450,43 @@ function _print_pdf_wkhtmltopdf($print, $html, $filename = NULL) {
  */
 function theme_print_pdf_dompdf_footer($vars) {
   preg_match('!<div class="print-footer">(.*?)</div>!si', $vars['html'], $tpl_footer);
-  $html = str_replace($tpl_footer[0], '', $vars['html']);
 
-  $text = '<script type="text/php">
-    if (isset($pdf)) {
-      $font = Font_Metrics::get_font("verdana");;
-      $size = 10;
-      $color = array(0,0,0);
-      $text_height = Font_Metrics::get_font_height($font, $size);
+  if (isset($tpl_footer[1])) {
+    $html = str_replace($tpl_footer[0], '', $vars['html']);
 
-      $w = $pdf->get_width();
-      $h = $pdf->get_height();
+    $text = '<script type="text/php">
+      if (isset($pdf)) {
+        $font = Font_Metrics::get_font("verdana");;
+        $size = 10;
+        $color = array(0,0,0);
+        $text_height = Font_Metrics::get_font_height($font, $size);
 
-      $footer = $pdf->open_object();
+        $w = $pdf->get_width();
+        $h = $pdf->get_height();
 
-      // Draw a line along the bottom
-      $y = $h - 25;
-      $pdf->line(15, $y, $w - 15, $y, $color, 1);
+        $footer = $pdf->open_object();
 
-      $y += $text_height / 2;
-      $pdf->page_text(15, $y, \'' . addslashes(strip_tags($tpl_footer[1])) . '\', $font, $size, $color);
+        // Draw a line along the bottom
+        $y = $h - 25;
+        $pdf->line(15, $y, $w - 15, $y, $color, 1);
 
-      $pdf->close_object();
-      $pdf->add_object($footer, "all");
+        $y += $text_height / 2;
+        $pdf->page_text(15, $y, \'' . addslashes(strip_tags($tpl_footer[1])) . '\', $font, $size, $color);
 
-      // Center the text
-      $width = Font_Metrics::get_text_width("Page 1 of 2", $font, $size);
-      $pagenumtxt = t("Page !n of !total", array("!n" => "{PAGE_NUM}", "!total" => "{PAGE_COUNT}"));
-      $pdf->page_text($w - 15 - $width, $y, $pagenumtxt, $font, $size, $color);
-    }
-  </script>';
+        $pdf->close_object();
+        $pdf->add_object($footer, "all");
 
-  return str_replace("<body>", "<body>" . $text, $html);
+        // Center the text
+        $width = Font_Metrics::get_text_width("Page 1 of 2", $font, $size);
+        $pagenumtxt = t("Page !n of !total", array("!n" => "{PAGE_NUM}", "!total" => "{PAGE_COUNT}"));
+        $pdf->page_text($w - 15 - $width, $y, $pagenumtxt, $font, $size, $color);
+      }
+    </script>';
+
+    return str_replace("<body>", "<body>" . $text, $html);
+  } else {
+    return $vars['html'];
+  }
 }
 
 /**
@@ -589,15 +599,17 @@ function theme_print_pdf_tcpdf_content($vars) {
 function theme_print_pdf_tcpdf_footer($vars) {
   $pdf = $vars['pdf'];
   preg_match('!<div class="print-footer">(.*?)</div>!si', $vars['html'], $tpl_footer);
-  $footer = trim(preg_replace('!</?div[^>]*?>!i', '', $tpl_footer[1]));
-
-  // set footer font
-  $vars['font'][2] *= 0.8;
-  $pdf->setFooterFont($vars['font']);
-  // set footer margin
-  $pdf->SetFooterMargin(10);
-  // set footer data
-  $pdf->SetFooterData($footer);
+  if (isset($tpl_footer[1])) {
+    $footer = trim(preg_replace('!</?div[^>]*?>!i', '', $tpl_footer[1]));
+
+    // set footer font
+    $vars['font'][2] *= 0.8;
+    $pdf->setFooterFont($vars['font']);
+    // set footer margin
+    $pdf->SetFooterMargin(10);
+    // set footer data
+    $pdf->setFooterContent($footer);
+  }
 
   return $pdf;
 }
diff --git a/drupal7/sites/all/modules/print/print_pdf/print_pdf.views.inc b/drupal7/sites/all/modules/print/print_pdf/print_pdf.views.inc
index f3dc6905..5068c1fd 100644
--- a/drupal7/sites/all/modules/print/print_pdf/print_pdf.views.inc
+++ b/drupal7/sites/all/modules/print/print_pdf/print_pdf.views.inc
@@ -33,7 +33,7 @@ function print_pdf_views_data() {
     'left_field' => 'nid',
     'field' => 'path',
 //    'type' => 'INNER',
-    'handler' => 'print_pdf_join_page_counter',
+    'handler' => 'print_join_page_counter',
   );
 
   // print_pdf_node_conf fields
diff --git a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc
index 10891865..1efec70e 100644
--- a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc
+++ b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc
@@ -40,7 +40,7 @@
  *
  */
 function _taxonomy_menu_insert_link_items_batch($vid) {
-  $terms = taxonomy_get_tree($vid);
+  $terms = taxonomy_get_tree($vid, 0, NULL, TRUE);
   $menu_name = variable_get(_taxonomy_menu_build_variable('vocab_menu', $vid), FALSE);
 
   $batch = array(
diff --git a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.info b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.info
index 80b82a79..295734e2 100644
--- a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.info
+++ b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.info
@@ -10,9 +10,9 @@ files[] = taxonomy_menu.module
 files[] = taxonomy_menu.test
 files[] = taxonomy_menu.install
 
-; Information added by drupal.org packaging script on 2012-09-06
-version = "7.x-1.4"
+; Information added by Drupal.org packaging script on 2014-04-01
+version = "7.x-1.5"
 core = "7.x"
 project = "taxonomy_menu"
-datestamp = "1346896425"
+datestamp = "1396359247"
 
diff --git a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.module b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.module
index 3d610990..7bcea712 100644
--- a/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.module
+++ b/drupal7/sites/all/modules/taxonomy_menu/taxonomy_menu.module
@@ -6,10 +6,10 @@
  */
 
 //include the database layer
-require_once(drupal_get_path('module', 'taxonomy_menu') . '/taxonomy_menu.database.inc');
+require_once(DRUPAL_ROOT . '/' . drupal_get_path('module', 'taxonomy_menu') . '/taxonomy_menu.database.inc');
 
 //include the batch functions
-require_once(drupal_get_path('module', 'taxonomy_menu') . '/taxonomy_menu.batch.inc');
+require_once(DRUPAL_ROOT . '/' . drupal_get_path('module', 'taxonomy_menu') . '/taxonomy_menu.batch.inc');
 
 /**
  * Implements hook_form_alter().
@@ -481,7 +481,12 @@ function _taxonomy_menu_taxonomy_termapi_helper($term, $operation) {
  */
 function _taxonomy_menu_nodeapi_helper($op, $terms = array(), $node) {
   foreach ($terms as $key => $tid) {
-    $term = taxonomy_term_load($tid);
+
+    // taxonomy_term_load($tid) return FALSE if the term was not found
+    // if taxonomy $term is false, then go to the next $term
+    if (!$term = taxonomy_term_load($tid)) {
+      continue;
+    }
 
     // update the menu for each term if necessary
     $menu_name = variable_get(_taxonomy_menu_build_variable('vocab_menu', $term->vid), FALSE);
@@ -754,7 +759,7 @@ function taxonomy_menu_path_default($vid, $tid) {
   }
   else {
     $path = 'taxonomy/term/' . $tid;
-    if (variable_get(_taxonomy_menu_build_variable('display_decendants', $vid), FALSE)) {
+    if (variable_get(_taxonomy_menu_build_variable('display_descendants', $vid), FALSE)) {
       // Use 'all' at the end of the path
       if (variable_get(_taxonomy_menu_build_variable('end_all', $vid), FALSE)) {
         $path .= '/all';
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc b/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
index 2f1ed197..e1b0b542 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.admin.inc
@@ -10,9 +10,12 @@
  */
 function webform_validation_manage($node) {
   $rules = webform_validation_get_webform_rules($node);
-  $output = '';
-  $output .= theme('webform_validation_manage_overview', array('rules' => $rules, 'node' => $node));
-  $output .= theme('webform_validation_manage_add_rule', array('nid' => $node->nid));
+  $output = array();
+  $output['webform_validation_manage_overview_form'] = drupal_get_form('webform_validation_manage_overview_form', $rules, $node);
+  $output['webform_validation_manage_add_rule'] = array(
+    '#theme' => 'webform_validation_manage_add_rule',
+    '#nid' => $node->nid,
+  );
   return $output;
 }
 
@@ -27,48 +30,126 @@ function webform_validation_get_webform_rules($node) {
   return $rules;
 }
 
+
 /**
- * Themable function to list the rules assigned to a webform
+ * Themable function to list and re-order the rules assigned to a webform
  */
-function theme_webform_validation_manage_overview($variables) {
-  $rules = $variables['rules'];
-  $node = $variables['node'];
+function theme_webform_validation_manage_overview_form($variables) {
+  $form = $variables['form'];
+  $header = array(t('Rule name'), t('Validator'), t('Components'), t('Weight'), array(
+    'data' => t('Operations'),
+    'colspan' => 2,
+  ));
 
-  $header = array(t('Rule name'), t('Validator'), t('Components'), array(
-      'data' => t('Operations'),
-      'colspan' => 2,
-    ));
-  $validators = webform_validation_get_validators_selection();
-  if (!empty($rules)) {
-    foreach ($rules as $rule) {
-      $component_info = webform_validation_rule_components_basic($rule['components']);
-      $row = array();
+  $rows = array();
+  foreach (element_children($form) as $rule) {
+    $row = array();
+    foreach (element_children($form[$rule]) as $item) {
+      //unset the titles of the form elements, since we are displaying them in a table with a header.
+      unset($form[$rule][$item]['#title']);
+      //add a class to the weight field
+      $form[$rule]['weight']['#attributes']['class'] = array('ruleid-weight');
       $row[] = array(
-        'data' => check_plain($rule['rulename']),
+        'data' => drupal_render($form[$rule][$item]),
       );
-      $row[] = array(
-        'data' => $validators[$rule['validator']],
-      );
-      $row[] = array(
-        'data' => theme('item_list', array('items' => $component_info)),
-      );
-      $row[] = array(
-        'data' => l(t('Edit'), 'node/' . $node->nid . '/webform/validation/edit/' . $rule['validator'] . '/' . $rule['ruleid'], array("query" => drupal_get_destination())),
-      );
-      $row[] = array(
-        'data' => l(t('Delete'), 'node/' . $node->nid . '/webform/validation/delete/' . $rule['ruleid'], array("query" => drupal_get_destination())),
+    }
+    if (count($row) > 1) {
+      $rows[] = array(
+        'data' => $row,
+        'class' => array('draggable'),
       );
-      $rows[] = $row;
+    }
+    // Hide any fieldsets, since we are displaying the form in a table.
+    if (isset($form[$rule]['#type']) && $form[$rule]['#type'] === 'fieldset') {
+      hide($form[$rule]);
     }
   }
-  else {
+  $drag = TRUE;
+  if (!$rows) {
+    $drag = FALSE;
     $rows[][] = array(
       'data' => t('No validation rules available.'),
       'colspan' => 5,
     );
   }
+  $output = theme('table', array('header' => $header, 'rows' => $rows, 'attributes' => array('id' => 'webform-validation-overview-form')));
+  $output .= drupal_render_children($form);
+  if ($drag) {
+    drupal_add_tabledrag('webform-validation-overview-form', 'order', 'sibling', 'ruleid-weight');
+  }
+  return $output;
+}
+
+/**
+ * Form to list and reorder the rules assigned to a webform
+ */
+function webform_validation_manage_overview_form($form, &$form_state, $rules, $node) {
+  $form = array();
+  $form['#tree'] = TRUE;
+  $validators = webform_validation_get_validators_selection();
 
-  return theme('table', array('header' => $header, 'rows' => $rows));
+  foreach ($rules as $rule) {
+    $component_info = webform_validation_rule_components_basic($rule['components']);
+    $form[$rule['ruleid']] = array(
+      '#type' => 'fieldset',
+    );
+    $form[$rule['ruleid']]['name'] = array(
+      '#type' => 'item',
+      '#title' => t('Name'),
+      '#markup' => check_plain($rule['rulename']),
+    );
+    $form[$rule['ruleid']]['validator'] = array(
+      '#type' => 'item',
+      '#title' => t('Validator'),
+      '#markup' => $validators[$rule['validator']],
+    );
+    $form[$rule['ruleid']]['components'] = array(
+      '#type' => 'item',
+      '#title' => t('Components'),
+      '#markup' => theme('item_list', array('items' => $component_info)),
+    );
+    $form[$rule['ruleid']]['weight'] = array(
+      '#type' => 'weight',
+      '#title' => t('Weight'),
+      '#default_value' => $rule['weight'],
+      '#description' => t('Optional. By changing the order of validation rules, you can use code that relies on earlier validation functions being completed.'),
+    );
+    $form[$rule['ruleid']]['actions'] = array('#type' => 'actions');
+    $form[$rule['ruleid']]['actions']['edit'] = array(
+      '#type' => 'item',
+      '#markup' => l(t('Edit'), 'node/' . $node->nid . '/webform/validation/edit/' . $rule['validator'] . '/' . $rule['ruleid'], array("query" => drupal_get_destination())),
+    );
+    $form[$rule['ruleid']]['actions']['delete'] = array(
+      '#type' => 'item',
+      '#markup' => l(t('Delete'), 'node/' . $node->nid . '/webform/validation/delete/' . $rule['ruleid'], array("query" => drupal_get_destination())),
+    );
+  }
+  if (count($rules) > 1) {
+    $form['submit'] = array(
+      '#type' => 'submit',
+      '#value' => t('Save rule order'),
+    );
+  }
+
+  return $form;
+}
+
+/**
+ * Submit function for rule overview form.
+ */
+function webform_validation_manage_overview_form_submit($form, $form_state) {
+  //Save the rule weights.
+  foreach ($form_state['values'] as $ruleid => $value) {
+    if (is_numeric($ruleid)) {
+      $update = db_update('webform_validation_rule')
+        ->fields(array(
+          'weight' => $value['weight'],
+        ))
+        ->condition('ruleid', $ruleid)
+        ->execute();
+    }
+  }
+  drupal_set_message(t('The order of the validation rules has been saved.'));
 }
 
 /**
@@ -256,6 +337,6 @@ function webform_validation_delete_rule($form, &$form_state, $rule) {
  */
 function webform_validation_delete_rule_submit($form, &$form_state) {
   $ruleid = $form_state['values']['ruleid'];
-  webform_dynamic_delete_rule($ruleid);
   module_invoke_all('webform_validation', 'rule', 'delete', $ruleid);
+  webform_dynamic_delete_rule($ruleid);
 }
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.info b/drupal7/sites/all/modules/webform_validation/webform_validation.info
index 7887ba01..3dba047f 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.info
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.info
@@ -9,9 +9,9 @@ files[] = webform_validation.module
 files[] = webform_validation.rules.inc
 files[] = webform_validation.validators.inc
 
-; Information added by Drupal.org packaging script on 2014-02-11
-version = "7.x-1.4"
+; Information added by Drupal.org packaging script on 2014-03-31
+version = "7.x-1.5"
 core = "7.x"
 project = "webform_validation"
-datestamp = "1392157410"
+datestamp = "1396296845"
 
diff --git a/drupal7/sites/all/modules/webform_validation/webform_validation.install b/drupal7/sites/all/modules/webform_validation/webform_validation.install
index 504e691a..26a91fc0 100644
--- a/drupal7/sites/all/modules/webform_validation/webform_validation.install
+++ b/drupal7/sites/all/modules/webform_validation/webform_validation.install
@@ -58,6 +58,13 @@ function webform_validation_schema() {
         'not null' => TRUE,
         'default' => 0,
       ),
+      'weight' => array(
+        'description' => 'Weight of the rule order.',
+        'type' => 'int',
+        'not null' => TRUE,
+        'unsigned' => FALSE,
+        'default' => 0,
+      ),
     ),
     'primary key' => array('ruleid'),
     'indexes' => array(
@@ -104,15 +111,14 @@ function webform_validation_update_1() {
     $range = $row->data;
     $range = _webform_validation_update_range_syntax($range);
     db_update('webform_validation_rule')
-    ->fields(array(
-      'data' => $range,
-    ))
-    ->condition('ruleid', $row->ruleid, '=')
-    ->execute();
+      ->fields(array(
+        'data' => $range,
+      ))
+      ->condition('ruleid', $row->ruleid, '=')
+      ->execute();
   }
   if ($has_numeric_validator) {
-    $warning_message = t('The numeric validation rule range syntax has changed with this release. Existing numeric validation rules were found and updated. Please verify that they still work as expected!');
-    drupal_set_message($warning_message, 'warning');
+    drupal_set_message(t('The numeric validation rule range syntax has changed with this release. Existing numeric validation rules were found and updated. Please verify that they still work as expected!'), 'warning');
   }
   return $ret;
 }
@@ -177,3 +183,30 @@ function webform_validation_update_7101() {
     }
   }
 }
+
+/**
+ * Rename oneoftwo and oneofseveral to someofseveral and default data to 1.
+ */
+function webform_validation_update_7104() {
+  db_update('webform_validation_rule')
+    ->fields(array(
+      'validator' => 'someofseveral',
+      'data' => 1,
+    ))
+    ->condition('validator', array('oneoftwo', 'oneofseveral'), 'IN')
+    ->execute();
+}
+
+/**
+ * Add a weight field to webform_validation rules, so they can be sorted.
+ */
+function webform_validation_update_7105() {
+  $spec = array(
+    'description' => 'Weight of the rule order.',
+    'type' => 'int',
+    'not null' => TRUE,
+    'unsigned' => FALSE,
+    'default' => 0,
+  );
+  db_add_field('webform_validation_rule', 'weight', $spec);
+}
